
/* Class: Array
 * Struttura dati per contenere l'insieme dei caratteri e delle loro frequenze
 */

public class Array {
	
	private char [] array;
	private int n;
	private int [] frequenze;

/* Method: Array
 * Costruttore classe Array, inizializza la struttura dato
 */
	
	public Array(){
		
		array = new char[1];
		frequenze = new int[1];
		n=0;
	}
	
/* Method: GetSize
 * Restituisce la dimensione attuale dell'Array
 */
	public int GetSize() {
		return n;
	}

/* Method: getmax
 * Restituisce la frequenza maggiore attualmente presente nell'Array  
 */
	
	public int getmax() {
		
		
		int max=0;
		for(int i=0;i<n;i++) {
			if(frequenze[i]>max) max=frequenze[i];
		}
		return max;	
	
	}
/* Method: Inserisci
 * Inserisce il nuovo carattere letto nell'Array: se non è presente lo inserisce e ne inizializza la frequenza a 0, altrimenti incrementa di 1 la sua frequenza 
 */
	public void Inserisci(int x) {
		
		char nuovo_c=(char)x;
		
		boolean found=false;
		for(int i=0;i<n;i++) {
			if(array[i]==nuovo_c) {
				found=true;
				frequenze[i]+=1;
			}
		}
		if(!found) {
		if(array.length==n) {
			char[] nuovo=new char[array.length*2];
			int [] fr_2= new int[frequenze.length*2];
			for(int i=0;i<array.length;i++) {
				nuovo[i]=array[i];
				fr_2[i]=frequenze[i];
			}
			array = nuovo;
			frequenze = fr_2;
			array[n]=nuovo_c;
			frequenze[n]=1;
			n++;
			return;
		}
		array[n]=nuovo_c;
		frequenze[n]=1;
		n++;
	}
	}
	
/* Method: Stampa 
 * Stampa il contenuto dell'Array, strutturandolo per coppie "Carattere"-"Frequenza"
 * 
 */
	public void Stampa() {
		for(int i=0;i<n;i++) {
			System.out.print("("+array[i]+","+frequenze[i]+")");
		}
	}

/*	Method: getChar 
 * Ritorna l'array di caratteri presenti nell'Array
 * 
 */
	public char[] getChar() {return array;}

/* Method: getFrequenze 
 * Ritorna l'array delle frequenze dell'Array
 * 
 */
	public int[] getFrequenze() {return frequenze;}
	
/* Method: Somma_Frequenze
 * Ritorna la somma di tutte le frequenze dell'Array
 * 
 */

	public int Somma_Frequenze() {
		int ret=0;
		for(int i=0;i<n;i++) {
			ret+=frequenze[i];
		}
		return ret;
	}
	
}
