
public class HuffMan_Tree {
	
	private static final char c='\0';
	private Nodo root;
	private Nodo[] array;
	private MinHeap Heap;
	private String[] codes;
	
	public int find(Nodo r) {
		int ret=-1;
		for(int i=0;i<array.length;i++) {
			if(array[i].getVal()==r.getVal()) {ret= i;}
		}
		return ret;
	}
	
	public void stampa_Array() {
		for(int i=0;i<array.length;i++) {
			array[i].Stampa_Nodo();
		}
	}
	
	
	public HuffMan_Tree(int n) {
		root=null;
		this.array=new Nodo[n];
		codes=new String[n];
	}
	
	public String find_Code(char _c) {
		for(int i=0;i<codes.length;i++) {
			if(array[i].getVal()==_c) return codes[i];
		}
		return null;
	}
	
	
	
	public void Fill(Nodo[] array,int n) {
		
		for(int i=0;i<n;i++) codes[i]="";
		
		for(int i=0;i<n;i++) {
			this.array[i]=array[i];
		}
		
		Heap=new MinHeap(array,n);
		
		
		while(Heap.getSize()>1) {
			Nodo aux_1= Heap.Extract();
			Nodo aux_2= Heap.Extract();
			
			Nodo r=new Nodo(c,aux_1.getFreq()+aux_2.getFreq());
			
			
			if(aux_1.getVal()>aux_2.getVal()) {
				r.setRight(aux_1);
				r.setLeft(aux_2);
			}
			else {
				r.setRight(aux_2);
				r.setLeft(aux_1);
			}
			root=r;
			Heap.Enqueue(r);
		}
		
		Set_Codes(root,"");
	}
	
	
	public void Set_Codes(Nodo r,String s) {
		
		if(r.getLeft()==null && r.getRight()==null) codes[find(r)]=s;
		else {
			
			Set_Codes(r.getLeft(),s+"0");
			Set_Codes(r.getRight(),s+"1");
		}
		
	}
	
	
	
	public void Print_Codes() {
		for(int i=0;i<codes.length;i++) {
			System.out.print("("+array[i].getVal() +","+codes[i]+") ");
		}
	}
	
	public Nodo getRoot() {return root;}
	public int Codes_Size() {return codes.length;}
	public String[] get_Codes() {return codes;}
	public Nodo[] get_Chars() {return array;}
	
	
	public String Decode(String s) {
		String ret="";
		
		Nodo iter=root;
		
		for(int i=0;i<s.length();i++) {
			if(s.charAt(i)=='0') 
				iter=iter.getLeft();
			else iter=iter.getRight();
			
			if(iter.getLeft()==null && iter.getRight()==null) {
				ret+=iter.getVal();
				iter=root;
			}
		}
		return ret;
	}
}
