/* Class: Nodo 
 * Struttura dato base per costruire l'albero di Huffman che contiene la coppia "Carattere"-"Frequenza"
 * 
 */

public class Nodo {
	private char val;
	private int frequenza;
	private Nodo right;
	private Nodo left;
	private Nodo padre;
	
/*Method: Nodo 
 * Costruttore classe Nodo, inizializza il valore del Carattere e della Frequenza
 * 
 */

	public Nodo(char c,int f) {
		val=c;
		frequenza=f;
		right=left=padre=null;
	}

/* Method: Stampa_Nodo 
 * Stampa i valori di Carattere e Frequenza
 * 
 */

	
	void Stampa_Nodo() {
		System.out.println("("+val+","+frequenza+") ");
	}
	
/* Method: getVal 
 * Ritorna il Carattere
 * 
 */

	public char getVal() {return val;}
	
	public boolean compare(Nodo x) {
		if(this.frequenza>x.frequenza) return true;
		else return false;
	}

	public Nodo getLeft() {
		return left;
	}

	public Nodo setLeft(Nodo left) {
		this.left = left;
		return left;
	}

	public Nodo getRight() {
		return right;
	}

	public void setRight(Nodo right) {
		this.right = right;
	}

	public Nodo getPadre() {
		return padre;
	}

	public Nodo setPadre(Nodo padre) {
		this.padre = padre;
		return padre;
	}
	
/* Method: getFreq 
 * Ritorna la Frequenza
 * 
 */

	public int getFreq() {return frequenza;}
	
	
}
